-- (C) 2012-2013 Miranda, Edition: 2016-2017-2018 Schrödinger
--------------------------------------------------------------------------------
-- 名前空間作成
if(_G and not _G.Kitty) then
	_G.Kitty = {
		name = "Kitty",
		Frames = {"KittyMinimap",},
	};
end

--------------------------------------------------------------------------------
-- 戦闘管理クラス
Kitty.ComboManager = {};
Kitty.ComboManager.TYPE_EFFECT = "EFFECT";
Kitty.ComboManager.TYPE_ACTION = "ACTION";
Kitty.ComboManager.TYPE_BUILD = "BUILD";
Kitty.ComboManager.TYPE_STRING_NUMBER_LIST = "STRING_NUMBER_LIST";
Kitty.ComboManager.TYPE_STRING = "STRING";
Kitty.ComboManager.TYPE_NUMBER = "NUMBER";
Kitty.ComboManager.TYPE_BOOLEAN = "BOOLEAN";
Kitty.ComboManager.TYPE_HIGH_STRING = "HIGH_STRING";
Kitty.ComboManager.TYPE_OTHER = "OTHER";

-- コマンドリスト
Kitty.ComboManager.commandList = {
{
	["info"]={["name"]="SWD", ["class"]="SWd", ["target"]="all"},
	{
		["commandType"]="equip", ["commandName"]=Kitty.T("skill", "Nightmare Blade Fragment"), ["icon"]="interface/icons/duties_stone_06.dds", ["enable"]=true,
		{["conditionType"]="playerBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Killing Intent"), ["threshold"]=10}},
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Hidden Peril"), ["icon"]="interface\\Icons\\elf_skill\\skill_ran_new25-2.dds", ["enable"]=true,
		{["conditionType"]="canCast", {["name"]=Kitty.T("skill", "Snipe"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Snipe"), ["icon"]="interface/icons/skill_ran18-1", ["enable"]=true,
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Hidden Peril"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Charged Chop"), ["icon"]="interface\\Icons\\elf_skill\\skill_ran_new30-4.dds", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="!Surt"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "ShotSWD"), ["icon"]="interface/icons/skill_ran1-2", ["enable"]=true,
	},
},
{
	["info"]={["name"]="RWL", ["class"]="RWl", ["target"]="all"},
	{
		["commandType"]="equip", ["commandName"]=Kitty.T("skill", "Nightmare Blade Fragment"), ["icon"]="interface/icons/duties_stone_06.dds", ["enable"]=true,
		{["conditionType"]="playerBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Killing Intent"), ["threshold"]=10}},
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Throw"), ["icon"]="interface/icons/skill_thi1-2", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Ghostly Strike"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_thi_har50-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Soul Stab"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_thi_har25-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Shadowstab"), ["icon"]="interface/icons/skill_thi1-1", ["enable"]=true,
		{["conditionType"]="targetNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Bleed(Rogue)"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Low Blow"), ["icon"]="interface/icons/skill_thi12-1", ["enable"]=true,
		{["conditionType"]="targetNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Grievous Wound(Low Blow)"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Wound Attack"), ["icon"]="interface/icons/skill_thi6-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Low Blow"), ["icon"]="interface/icons/skill_thi12-1", ["enable"]=true,
		{["conditionType"]="playerEnergy", ["min"]=60, ["max"]=nil},
	},
},
{
	["info"]={["name"]="WM", ["class"]="WM", ["target"]="all"},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Lightning Burn Weapon"), ["icon"]="interface\\Icons\\elf_skill\\skill_war_mag60.dds", ["enable"]=true,
		{["conditionType"]="playerNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Lightning Burn Weapon"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Electrical Rage"), ["icon"]="interface/icons/skill_war_new15-3", ["enable"]=true,
		{["conditionType"]="playerNonBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "High Voltage"), ["threshold"]=3}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Electrical Rage"), ["icon"]="interface/icons/skill_war_new15-3", ["enable"]=true,
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "High Voltage"), ["threshold"]=-2.4}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Attack"), ["icon"]="interface//Icons//skill_att.dds", ["enable"]=true,
		{["conditionType"]="targetIsDead", ["value"]=false},
	},
},
{
	["info"]={["name"]="CHR", ["class"]="ChR", ["target"]="all"},
	{
		["commandType"]="equip", ["commandName"]=Kitty.T("skill", "Nightmare Blade Fragment"), ["icon"]="interface/icons/duties_stone_06.dds", ["enable"]=false,
		{["conditionType"]="playerBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Killing Intent"), ["threshold"]=10}},
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Forge"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy2-1", ["enable"]=true,
		{["conditionType"]="playerNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Forge"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Rune Energy Influx"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy18-2", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=35, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Rune Growth"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy24-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Shadow Pulse"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy_thi20-1", ["enable"]=true,
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Chain Drive"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Rune Pulse"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy10-1", ["enable"]=false,
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Chain Drive"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Throw"), ["icon"]="interface/icons/skill_thi1-2", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Shadowstab"), ["icon"]="interface/icons/skill_thi1-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Attack"), ["icon"]="interface//Icons//skill_att.dds", ["enable"]=true,
		{["conditionType"]="targetIsDead", ["value"]=false},
	},
},
{
	["info"]={["name"]="CHK", ["class"]="ChK", ["target"]="all"},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Forge"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy2-1", ["enable"]=true,
		{["conditionType"]="playerNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Forge"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Rune Energy Influx"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy18-2", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=45, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Rune Growth"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy24-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Rune Pulse"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy10-1", ["enable"]=true,
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Chain Drive"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Holy Strike"), ["icon"]="interface/icons/skill_kni5-1.dds", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Attack"), ["icon"]="interface//Icons//skill_att.dds", ["enable"]=true,
		{["conditionType"]="targetIsDead", ["value"]=false},
	},
},
{
	["info"]={["name"]="RM", ["class"]="RM", ["target"]="all"},
	{
		["commandType"]="equip", ["commandName"]=Kitty.T("skill", "Nightmare Blade Fragment"), ["icon"]="interface/icons/duties_stone_06.dds", ["enable"]=true,
		{["conditionType"]="playerBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Killing Intent"), ["threshold"]=10}},
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Throw"), ["icon"]="interface/icons/skill_thi1-2", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Shadowstab"), ["icon"]="interface/icons/skill_thi1-1", ["enable"]=true,
		{["conditionType"]="targetNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Bleed(Rogue)"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Low Blow"), ["icon"]="interface/icons/skill_thi12-1", ["enable"]=true,
		{["conditionType"]="targetNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Grievous Wound(Low Blow)"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Wound Attack"), ["icon"]="interface/icons/skill_thi6-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Low Blow"), ["icon"]="interface/icons/skill_thi12-1", ["enable"]=true,
		{["conditionType"]="playerEnergy", ["min"]=60, ["max"]=nil},
	},
},
{
	--            
	["info"]={["name"]="WLCH", ["class"]="WlCh", ["target"]="all"},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Rage Sublimation"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_psy60-1.dds", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=100, ["max"]=nil},
		{["conditionType"]="playerNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Willpower Blade"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Willpower Blade"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_0-1.dds", ["enable"]=true,
		{["conditionType"]="playerSoulPoint", ["min"]=6, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Saces' Impulse"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_psy45-1.dds", ["enable"]=true,
		{["conditionType"]="playerNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Saces' Impulse"), ["threshold"]=0}},
		{["conditionType"]="playerSoulPoint", ["min"]=2, ["max"]=nil},
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Willpower Blade"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Saces' Fury"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_psy15-1.dds", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=10, ["max"]=nil},
		{["conditionType"]="playerNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Saces' Fury"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Weakening Weave Curse"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har4-1.dds", ["enable"]=true,
		{["conditionType"]="targetNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Weakened(Warlock)"), ["threshold"]=0}},
		{["conditionType"]="playerFocus", ["min"]=20, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Electrocution"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_psy1-2.dds", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=20, ["max"]=nil},
		{["conditionType"]="targetName", ["value"]="!Surt"},
		{["conditionType"]="targetNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Weakened(Warlock)"), ["threshold"]=2}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Rune Energy Devotion"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_psy35-1.dds", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=nil, ["max"]=70},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Puzzlement"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har32-1.dds", ["enable"]=true,
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Saces' Fury"), ["threshold"]=0}},
		{["conditionType"]="targetEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Electrocution"), ["threshold"]=0}},
		{["conditionType"]="targetEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Weakened(Warlock)"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Heart Collection Strike"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har22-1.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=nil, ["max"]=50},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Severed Consciousness"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har10-1.dds", ["enable"]=true,
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Willpower Blade"), ["threshold"]=0}},
		{["conditionType"]="playerSoulPoint", ["min"]=2, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Warp Charge"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har1-2.dds", ["enable"]=true,
		{["conditionType"]="playerNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Warp Charge"), ["threshold"]=0}},
		{["conditionType"]="playerFocus", ["min"]=30, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Psychic Arrows"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har1-1.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=20, ["max"]=nil},
	},
},
{
	["info"]={["name"]="WLM", ["class"]="WlM", ["target"]="all"},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Warp Charge"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har1-2.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=35, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Perception Extraction"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har6-1.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=15, ["max"]=nil},
		{["conditionType"]="targetNonDebuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Soul Brand"), ["threshold"]=4}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Perception Extraction"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har6-1.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=15, ["max"]=nil},
		{["conditionType"]="targetEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Soul Brand"), ["threshold"]=-2}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Heart Collection Strike"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har22-1.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=nil, ["max"]=50},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Weakening Weave Curse"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har4-1.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=25, ["max"]=nil},
		{["conditionType"]="targetNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Weakened(Warlock)"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Focus Building"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_mag30-1.dds", ["enable"]=true,
		{["conditionType"]="playerNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Focus Building"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Thinking Overload"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_mag50-1.dds", ["enable"]=true,
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Intensification"), ["icon"]="interface/icons/skill_mag12-2", ["enable"]=true,
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Flaming Heart Strike"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_mag20-1.dds", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Soul Brand Sting"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_mag45-1.dds", ["enable"]=true,
		{["conditionType"]="playerSoulPoint", ["min"]=1, ["max"]=nil},
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Willpower Blade"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Willpower Blade"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har_0-1.dds", ["enable"]=true,
		{["conditionType"]="playerSoulPoint", ["min"]=6, ["max"]=nil},
		{["conditionType"]="playerNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Willpower Blade"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Puzzlement"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har32-1.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=25, ["max"]=nil},
		{["conditionType"]="targetEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Weakened(Warlock)"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Psychic Arrows"), ["icon"]="interface\\Icons\\dwarf_skill\\skill_har1-1.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=25, ["max"]=nil},
	},
},
{
	["info"]={["name"]="SR", ["class"]="SR", ["target"]="all"},
	{
		["commandType"]="equip", ["commandName"]=Kitty.T("skill", "Nightmare Blade Fragment"), ["icon"]="interface/icons/duties_stone_06.dds", ["enable"]=true,
		{["conditionType"]="playerBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Killing Intent"), ["threshold"]=10}},
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Reflected Shot"), ["icon"]="interface/icons/skill_ran27-1", ["enable"]=true,
		{["conditionType"]="targetIsBoss", ["value"]=false},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Piercing Arrow"), ["icon"]="interface/icons/skill_ran21-1", ["enable"]=true,
		{["conditionType"]="targetIsBoss", ["value"]=false},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Shot"), ["icon"]="interface/icons/skill_ran1-2", ["enable"]=true,
		{["conditionType"]="afterPlayerBuffEnded", {["name"]=toName( 503169 ), ["threshold"]=20}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Sapping Arrow"), ["icon"]="interface/icons/skill_ran_new25-2", ["enable"]=true,
		{["conditionType"]="targetNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Sapping Arrow"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Snipe"), ["icon"]="interface/icons/skill_ran18-1", ["enable"]=true,
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Arcane Potion"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Vampire Arrows"), ["icon"]="interface/icons/skill_ran6-3.dds", ["enable"]=true,
		{["conditionType"]="canCast", {["name"]=Kitty.T("skill", "Deadly Poison Bite"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Deadly Poison Bite"), ["icon"]="interface/icons/skill_ran_new35-6", ["enable"]=true,
		{["conditionType"]="targetDebuffStack", {["effectType"]="original", ["name"]=Kitty.T("skill", "Vampire Arrows"), ["threshold"]="S"}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Combo Shot"), ["icon"]="interface/icons/skill_ran3-1", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="!Ah-Patnar-Unicob"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Reflected Shot"), ["icon"]="interface/icons/skill_ran27-1", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="!Ixchel"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Piercing Arrow"), ["icon"]="interface/icons/skill_ran21-1", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="!Ixchel"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Weak Spot"), ["icon"]="interface/icons/skill_ran_new20-2.tga", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Mana Drain Shot"), ["icon"]="interface/icons/skill_ran12-2", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Wind Arrows"), ["icon"]="interface/icons/skill_ran3-3.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=25},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Shot"), ["icon"]="interface/icons/skill_ran1-2", ["enable"]=true,
	},
},
{
	["info"]={["name"]="SW", ["class"]="SW", ["target"]="all"},
	{
		["commandType"]="equip", ["commandName"]=Kitty.T("skill", "Nightmare Blade Fragment"), ["icon"]="interface/icons/duties_stone_06.dds", ["enable"]=true,
		{["conditionType"]="playerBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Killing Intent"), ["threshold"]=10}},
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Target Lock"), ["icon"]="interface/icons/skill_ran_new35-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Shot"), ["icon"]="interface/icons/skill_ran1-2", ["enable"]=true,
		{["conditionType"]="afterPlayerBuffEnded", {["name"]=toName( 503255 ), ["threshold"]=20}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Snipe"), ["icon"]="interface/icons/skill_ran18-1", ["enable"]=true,
		{["conditionType"]="playerEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Arcane Potion"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Combo Shot"), ["icon"]="interface/icons/skill_ran3-1", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="!Ah-Patnar-Unicob"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Reflected Shot"), ["icon"]="interface/icons/skill_ran27-1", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="!Ixchel"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Piercing Arrow"), ["icon"]="interface/icons/skill_ran21-1", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="!Ixchel"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Mana Drain Shot"), ["icon"]="interface/icons/skill_ran12-2", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Vampire Arrows"), ["icon"]="interface/icons/skill_ran6-3.dds", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Wind Arrows"), ["icon"]="interface/icons/skill_ran3-3.dds", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=25},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Shot"), ["icon"]="interface/icons/skill_ran1-2", ["enable"]=true,
	},
},
{
	["info"]={["name"]="WDW", ["class"]="WdW", ["target"]="all"},
	{
		["commandType"]="equip", ["commandName"]=Kitty.T("skill", "Nightmare Blade Fragment"), ["icon"]="interface/icons/duties_stone_06.dds", ["enable"]=true,
		{["conditionType"]="playerBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Killing Intent"), ["threshold"]=10}},
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Energy Absorb"), ["icon"]="interface/icons/elf_skill/skill_ward1-4.dds", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Pulse Mastery"), ["icon"]="interface\\Icons\\elf_skill\\skill_ward_new20-4.dds", ["enable"]=true,
		{["conditionType"]="targetEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Beast Sigil"), ["threshold"]=0}},
		{["conditionType"]="playerTension", ["min"]=20, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Beast Chop"), ["icon"]="interface\\Icons\\elf_skill\\skill_war_new35-1.dds", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=20, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Frantic Briar"), ["icon"]="interface/icons/elf_skill/skill_ward26-1.dds", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Charged Chop"), ["icon"]="interface/icons/elf_skill/skill_ward1-1.dds", ["enable"]=true,
	},
},
{
	["info"]={["name"]="KP", ["class"]="KP", ["target"]="all"},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Charge"), ["icon"]="interface/icons/skill_kni21-2", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="!Surt"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Truth Shield Bash"), ["icon"]="interface/icons/skill_kni27-2", ["enable"]=true,
		{["conditionType"]="targetDebuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Holy Seal"), ["threshold"]=4}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Holy Power Explosion"), ["icon"]="interface/icons/skill_kni12-2", ["enable"]=true,
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Threaten"), ["icon"]="interface/icons/skill_kni16-1", ["enable"]=true,
		{["conditionType"]="targetNonDebuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Holy Seal"), ["threshold"]=4}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Disarmament"), ["icon"]="interface/icons/skill_kni12-1", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="Yaotl"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Holy Smite"), ["icon"]="interface/icons/skill_kni_new15-4.tga", ["enable"]=true,
		{["conditionType"]="targetDebuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Holy Seal"), ["threshold"]=4}},
		{["conditionType"]="playerHealth", ["max"]=75},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Whirlwind Shield"), ["icon"]="interface/icons/skill_kni20-1.dds", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Holy Seal"), ["icon"]="interface/icons/skill_kni10-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Holy Strike"), ["icon"]="interface/icons/skill_kni5-1.dds", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Attack"), ["icon"]="interface//Icons//skill_att.dds", ["enable"]=true,
		{["conditionType"]="targetIsDead", ["value"]=false},
	},
},
{
	["info"]={["name"]="KW", ["class"]="KW", ["target"]="all"},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Charge"), ["icon"]="interface/icons/skill_kni21-2", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="!Surt"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Truth Shield Bash"), ["icon"]="interface/icons/skill_kni27-2", ["enable"]=true,
		{["conditionType"]="targetDebuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Holy Seal"), ["threshold"]=4}},
		{["conditionType"]="targetEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Divine Punishment")}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Holy Power Explosion"), ["icon"]="interface/icons/skill_kni12-2", ["enable"]=true,
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Threaten"), ["icon"]="interface/icons/skill_kni16-1", ["enable"]=true,
		{["conditionType"]="targetNonDebuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Holy Seal"), ["threshold"]=4}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Disarmament"), ["icon"]="interface/icons/skill_kni12-1", ["enable"]=true,
		{["conditionType"]="targetName", ["value"]="Yaotl"},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Holy Strike"), ["icon"]="interface/icons/skill_kni5-1.dds", ["enable"]=true,
		{["conditionType"]="targetNonDebuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Holy Seal"), ["threshold"]=1}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Punishment"), ["icon"]="interface/icons/skill_kni1-2", ["enable"]=true,
		{["conditionType"]="targetDebuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Holy Seal"), ["threshold"]=1}},
		{["conditionType"]="targetNonEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Divine Punishment")}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Whirlwind Shield"), ["icon"]="interface/icons/skill_kni20-1.dds", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Authoritative Deterrence"), ["icon"]="interface/icons/skill_kni_new50-6", ["enable"]=true,
		{["conditionType"]="targetEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Elemental Extraction")}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Holy Seal"), ["icon"]="interface/icons/skill_kni10-1", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Authoritative Deterrence"), ["icon"]="interface/icons/skill_kni_new50-6", ["enable"]=true,
		{["conditionType"]="targetOnMe", ["value"]=false},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Holy Strike"), ["icon"]="interface/icons/skill_kni5-1.dds", ["enable"]=true,
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Attack"), ["icon"]="interface//Icons//skill_att.dds", ["enable"]=true,
		{["conditionType"]="targetIsDead", ["value"]=false},
	},
},
{
	["info"]={["name"]="WS", ["class"]="WS", ["target"]="all"},
	{
		["commandType"]="equip", ["commandName"]=Kitty.T("skill", "Nightmare Blade Fragment"), ["icon"]="interface/icons/duties_stone_06.dds", ["enable"]=true,
		{["conditionType"]="playerBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Killing Intent"), ["threshold"]=10}},
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "The Final Battle"), ["icon"]="interface/icons/skill_war_new50-3.dds", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=30, ["max"]=nil},
		{["conditionType"]="targetHealth", ["min"]=nil, ["max"]=30},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Aim for the Wound"), ["icon"]="interface/icons/skill_war_new15-1", ["enable"]=true,
		{["conditionType"]="playerNonEffect", {["effectType"]="name", ["name"]=toName( 620339 ), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Open Flank"), ["icon"]="interface/icons/skill_war3-2", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=10, ["max"]=nil},
		{["conditionType"]="targetEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Vulnerable"), ["threshold"]=0}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Probing Attack"), ["icon"]="interface/icons/skill_thi3-1.dds", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=20, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Skull Breaker"), ["icon"]="interface/icons/skill_war_new45-1", ["enable"]=true,
		{["conditionType"]="playerFocus", ["min"]=30, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Slash"), ["icon"]="interface/icons/skill_war1-1", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=30, ["max"]=nil},
	},

},
{
	["info"]={["name"]="WWD", ["class"]="WWd", ["target"]="all"},
	{
		["commandType"]="equip", ["commandName"]=Kitty.T("skill", "Nightmare Blade Fragment"), ["icon"]="interface/icons/duties_stone_06.dds", ["enable"]=true,
		{["conditionType"]="playerBuffStack", {["effectType"]="original", ["name"]=Kitty.T("effect", "Killing Intent"), ["threshold"]=10}},
		{["conditionType"]="targetIsBoss", ["value"]=true},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Savage Whirlwind"), ["icon"]="interface\\icons\\elf_skill\\skill_war_new30-3.dds", ["enable"]=true,
		{["conditionType"]="afterPlayerBuffEnded", {["name"]=toName( 504901 ), ["threshold"]=40}},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Open Flank"), ["icon"]="interface/icons/skill_war3-2", ["enable"]=true,
		{["conditionType"]="targetEffect", {["effectType"]="original", ["name"]=Kitty.T("effect", "Vulnerable"), ["threshold"]=0}},
		{["conditionType"]="playerTension", ["min"]=10, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Probing Attack"), ["icon"]="interface/icons/skill_thi3-1.dds", ["enable"]=true,
		{["conditionType"]="playerTension", ["min"]=20, ["max"]=nil},
	},
	{
		["commandType"]="skill", ["commandName"]=Kitty.T("skill", "Charged Chop"), ["icon"]="interface/icons/elf_skill/skill_ward1-1.dds", ["enable"]=true,
	},
},
};

Kitty.ComboManager.formatMessage = function(message)
	local replaceList = {
		["s"] = tostring(UnitName("player")),					-- プレイヤー名
		["t"] = tostring(UnitName("target")),					-- ターゲット名
		["b"] = tostring(Kitty.lastBuffName),					-- バフ名称
		["d"] = string.format("%.2f", Kitty.lastDuration),		-- バフ残り効果時間

		["S"] = Kitty.colorCyan(tostring(UnitName("player"))),				-- プレイヤー名
		["T"] = Kitty.colorCyan(tostring(UnitName("target"))),				-- ターゲット名
		["B"] = Kitty.colorCyan(tostring(Kitty.lastBuffName)),				-- バフ名称
		["D"] = Kitty.colorCyan(string.format("%.2f", Kitty.lastDuration)),	-- バフ残り効果時間
	};

	return string.gsub(message, "%%(%w)", replaceList);
end;
-- クラスから、関数名を取得Helpのあるものを抽出
Kitty.ComboManager.createFunctionList = function()
	local resultList = {};
	local suffix = "Describe";

	for funcName, func in pairs(Kitty.ComboManager) do
		if(type(funcName) == "string" and type(func) == "function") then
			if(string.endsWith(funcName, suffix)) then
				local originalFuncName = string.sub(funcName, 1, -string.len(suffix)-1);
				-- もともとの関数
				if(originalFuncName ~= "func" and originalFuncName ~= "show" and originalFuncName ~= "commandList" and originalFuncName ~= "command") then
					local helpFuncName = funcName .. "Help";
					local describeFuncName = originalFuncName .. "Describe";
					local typeFuncName = originalFuncName .. "Type";

					resultList[originalFuncName] = {};
					resultList[originalFuncName][originalFuncName] = Kitty.ComboManager[originalFuncName];
					resultList[originalFuncName][helpFuncName] = Kitty.ComboManager[helpFuncName];
					resultList[originalFuncName][describeFuncName] = Kitty.ComboManager[describeFuncName];
					resultList[originalFuncName][typeFuncName] = Kitty.ComboManager[typeFuncName];
				end
			end
		end
	end

	return resultList;
end;

Kitty.ComboManager.getFormatType = function(conditionType)
	assert(conditionType, "ConditionType is nil.");
	return Kitty.ComboManager[conditionType .. "Type"](nil, nil);
end;

-- 引数を抽出
Kitty.ComboManager.getArgument = function(condition)
	local formatType = Kitty.ComboManager.getFormatType(condition.conditionType);
	if(formatType == Kitty.ComboManager.TYPE_EFFECT) then
		return condition;
	elseif(formatType == Kitty.ComboManager.TYPE_ACTION) then
		return condition.value;
	elseif(formatType == Kitty.ComboManager.TYPE_BUILD) then
		return condition.value;
	elseif(formatType == Kitty.ComboManager.TYPE_STRING_NUMBER_LIST) then
		return condition;
	elseif(formatType == Kitty.ComboManager.TYPE_STRING) then
		return condition.value;
	elseif(formatType == Kitty.ComboManager.TYPE_NUMBER) then
		return condition.min, condition.max;
	elseif(formatType == Kitty.ComboManager.TYPE_BOOLEAN) then
		return condition.value;
	elseif(formatType == Kitty.ComboManager.TYPE_HIGH_STRING) then
		return condition.value;
	else
		return condition;
	end
end;

-- 状態判定関数
Kitty.ComboManager.getTargetState = function()
	if(UnitName("target") == nil or UnitIsUnit("target", "player")) then
		return "none";
	else
		if(UnitIsPlayer("target")) then
			return "pc", "all";
		else
			if(UnitSex("target") >= 3) then
				return "boss", "all";
			else
				return "all";
			end
		end
	end
end;
-- 指定ビルドのコマンドリストを抽出
Kitty.ComboManager.pickupCommandList = function(allCommandList, mainClass, subClass)
	local result = {};
	local className = nil;
	if(mainClass == "" and subClass == "") then
		className = "any";
	elseif(mainClass == "") then
		className = "/" .. subClass;
	else
		className = mainClass .. subClass;
	end

	for index, commandList in ipairs(allCommandList) do
		if(commandList ~= nil and commandList.info ~= nil) then
			if(commandList.info.class == className) then	-- 完全一致
				if(result[commandList.info.target] == nil) then
					-- 最初のものを優先
					result[commandList.info.target] = commandList;
				else
					-- 重複
--					Kitty.sendMessage(Kitty.format("Command list is duplicated. Class:[<<1>>], Target:[<<2>>]", tostring(mainClass) .. tostring(subClass), tostring(commandList.info.target)), "DEFAULT", 1, 0, 0);
				end
			end
		end
	end

	return result;
end;

Kitty.ComboManager.selectCommandList = function(mainClass, subClass)
	local targetStateList = {Kitty.ComboManager.getTargetState()};

	-- メイン、サブ指定のコマンドリスト
	local targetCommandListMap = Kitty.ComboManager.pickupCommandList(Kitty.SettingManager.setting.command, mainClass, subClass);
	for _, targetState in ipairs(targetStateList) do
		if(targetCommandListMap[targetState] ~= nil) then
			return targetCommandListMap[targetState], targetState;
		end
	end

	-- メインのみ指定のコマンドリス
	local targetCommandListMap = Kitty.ComboManager.pickupCommandList(Kitty.SettingManager.setting.command, mainClass, "");
	for _, targetState in ipairs(targetStateList) do
		if(targetCommandListMap[targetState] ~= nil) then
			return targetCommandListMap[targetState], targetState;
		end
	end

	-- サブのみ指定のコマンドリス
	local targetCommandListMap = Kitty.ComboManager.pickupCommandList(Kitty.SettingManager.setting.command, "", subClass);
	for _, targetState in ipairs(targetStateList) do
		if(targetCommandListMap[targetState] ~= nil) then
			return targetCommandListMap[targetState], targetState;
		end
	end

	-- クラス指定なしのコマンドリス
	local targetCommandListMap = Kitty.ComboManager.pickupCommandList(Kitty.SettingManager.setting.command, "", "");
	for _, targetState in ipairs(targetStateList) do
		if(targetCommandListMap[targetState] ~= nil) then
			return targetCommandListMap[targetState], targetState;
		end
	end

	-- 未サポート
	return nil;
end;
Kitty.ComboManager.selectCommandListByName = function(commandListNames)
	local list = {};
	for _, name in ipairs(commandListNames) do
		list[name] = true;
	end

	local resultList = {};
	for _, commandList in pairs(Kitty.SettingManager.setting.command) do
		if(commandList.info ~= nil) then
			if(list[commandList.info.name] ~= nil) then
				table.insert(resultList, commandList);
			end
		end
	end
	return resultList;
end;

Kitty.ComboManager.getSupportedClass = function(allCommandList)
	local map = {};
	-- ダブり落とし
	for index, commandList in ipairs(allCommandList) do
		if(commandList.info ~= nil and commandList.info.class ~= nil) then
			map[commandList.info.class] = true;
		end
	end

	-- 配列に変換
	local array = {};
	for key, _ in pairs(map) do
		table.insert(array, key);
	end

	table.sort(array);
	return array;
end;
Kitty.ComboManager.isSupportedClass = function(allCommandList, className)
	for index, commandList in ipairs(allCommandList) do
		if(commandList.info ~= nil and commandList.info.class ~= nil) then
			if(Kitty.BuildManager.match(className, commandList.info.class)) then
				return true;
			end
		end
	end
	return false;
end;

--------------------------------------------------------------------------------
-- ヘルプ
Kitty.ComboManager.showHelp = function(allCommandList, className)
	local resultList = {};

	for index, commandList in ipairs(allCommandList) do
		if(commandList ~= nil and commandList.info ~= nil) then
			if(commandList.info.class == className) then	-- 完全一致

				if(commandList.info.target == "all") then
					table.insert(resultList, Kitty.T("message", "Skill02"));
				elseif(commandList.info.target == "pc") then
					table.insert(resultList, Kitty.T("message", "Skill03"));
				elseif(commandList.info.target == "boss") then
					table.insert(resultList, Kitty.T("message", "Skill06"));
				elseif(commandList.info.target == "none") then
					table.insert(resultList, Kitty.T("message", "Skill05"));
				else
					table.insert(resultList, Kitty.T("message", "UnsupportedTarget", tostring(commandList.info.target)));
					break;
				end

				resultList = Kitty.concatTable(resultList, Kitty.ComboManager.commandListHelp(commandList));
			end
		end
	end

	if(#resultList == 0) then
		table.insert(resultList, Kitty.T("message", "UnsupportedClass", className));
	end

	return resultList;
end;
Kitty.ComboManager.commandListHelp = function(targetList)
	local resultList = {};
	-- コマンドごとにループ
	for index, command in ipairs(targetList) do
		local commandName = nil;
		if(command.commandName ~= nil and command.commandName ~= "") then
			commandName = command.commandName
		else
			commandName = "<none>";
		end

		-- 有効なコマンド
		if(command.enable ~= false) then	-- nilは実行する
			if(command.commandType ~= nil and command.commandType ~= "") then
				-- No, Skill名
				local message = Kitty.color(tostring(index), 255, 255, 255) .. "."
							.. Kitty.ComboManager.formatCommandType(command.commandType)
							.. Kitty.color(tostring(commandName), 255, 255, 0);
				table.insert(resultList, message);
				-- 発動条件
				local strList = Kitty.ComboManager.commandHelp(command);
				table.insert(resultList, strList);	-- 配列の要素に配列を代入
			else
				table.insert(resultList, Kitty.color(tostring(index) .. ".", 255, 255, 255)
										.. Kitty.color(Kitty.ComboManager.formatCommandType(command.commandType)
										.. Kitty.T("message", "Invalid"), 255, 0, 0));
			end
		else
			local message = Kitty.color(tostring(index) .. ".", 255, 255, 255)
										.. Kitty.ComboManager.formatCommandType(command.commandType)
										.. tostring(commandName)
										.. Kitty.color(Kitty.T("message", "Disable"), 255, 0, 255);
			table.insert(resultList, message);
		end
	end

	return resultList;
end;
Kitty.ComboManager.commandHelp = function(command)
	local resultList = {};
	if(command ~= nil) then
		-- 発動条件
		for index, condition in ipairs(command) do
			local func = Kitty.ComboManager[condition.conditionType .. "Help"];
			assert(func, "Error: Function:[" .. tostring(condition.conditionType .. "Help") .. "] is nothing.");
			local conditionMessage = func(nil, Kitty.ComboManager.getArgument(condition));	-- インスタンスメソッドだが、インスタンスは未使用
			if(type(conditionMessage) == "string") then
				conditionMessage = {conditionMessage};
			end

			for _, value in ipairs(conditionMessage) do
				table.insert(resultList, Kitty.color(value, 255, 255, 255));
			end
		end
	end
	return resultList;
end;
Kitty.ComboManager.formatCommandType = function(commandType)
	if(commandType == "skill") then
		return Kitty.colorGreen("K");
	elseif(commandType == "suitskill") then
		return Kitty.colorGreen("S");
	elseif(commandType == "equip") then
		return Kitty.colorGreen("EQ");
	elseif(commandType == "action") then
		return Kitty.colorGreen("A");
	elseif(commandType == "extra") then
		return Kitty.colorGreen("X");
	elseif(commandType == "emote") then
		return Kitty.colorGreen("EM");
	elseif(commandType == "macro") then
		return Kitty.colorGreen("M");
	elseif(commandType == "bag") then
		return Kitty.colorGreen("B");
	else
		return Kitty.colorMagenta("?");
	end
end;

--------------------------------------------------------------------------------
-- インスタンスメソッド

Kitty.ComboManager.playerCastSpeed = function(self, min, max)
	local Base, Bonus = GetPlayerAbility( "MAGIC_CASTSPEED" )
	local Speed = Bonus
	
	max = max or 1000
	min = min or 0
	
	if Speed <= max and Speed >= min then
		return true
	end
	
	return false
end;
Kitty.ComboManager.playerCastSpeedHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "CastSpeed1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "CastSpeed2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "CastSpeed3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerCastSpeedDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerCastSpeedDescription1"),
		Kitty.T("message", "playerCastSpeedDescription2"),
		Kitty.T("message", "playerCastSpeedDescription3"),
	};
end;
Kitty.ComboManager.playerCastSpeedType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;

Kitty.ComboManager.playerCastSpeedMinMax = function( self )
	return 0, 1000
end
-------------
Kitty.ComboManager.playerMainHandSpeed = function(self, min, max)
	local Base, Bonus = GetPlayerAbility( "MAIN_ATTACKSPEED")
	local Speed = Base + Bonus
	
	max = max or 5
	min = min or 0
	
	if Speed <= max and Speed >= min then
		return true
	end
	
	return false
end;
Kitty.ComboManager.playerMainHandSpeedHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "MainHandSpeed1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "MainHandSpeed2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "MainHandSpeed3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerMainHandSpeedDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerMainHandSpeedDescription1"),
		Kitty.T("message", "playerMainHandSpeedDescription2"),
		Kitty.T("message", "playerMainHandSpeedDescription3"),
	};
end;
Kitty.ComboManager.playerMainHandSpeedType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.playerMainHandSpeedMinMax = function( self )
	return 0.5, 4
end
-----------------------------------------------------------------------------------------
Kitty.ComboManager.playerOffHandSpeed = function(self, min, max)
	local Base, Bonus = GetPlayerAbility( "OFF_ATTACKSPEED")
	local Speed = Base + Bonus
	
	max = max or 5
	min = min or 0
	
	if Speed <= max and Speed >= min then
		return true
	end
	
	return false
end;
Kitty.ComboManager.playerOffHandSpeedHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "OffHandSpeed1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "OffHandSpeed2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "OffHandSpeed3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerOffHandSpeedDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerOffHandSpeedDescription1"),
		Kitty.T("message", "playerOffHandSpeedDescription2"),
		Kitty.T("message", "playerOffHandSpeedDescription3"),
	};
end;
Kitty.ComboManager.playerOffHandSpeedType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.playerOffHandSpeedMinMax = function( self )
	return 0.5, 4
end
-----------------------------------------------------------------------------------------
Kitty.ComboManager.playerBowSpeed = function(self, min, max)
	local Base, Bonus = GetPlayerAbility( "BOW_ATTACKSPEED")
	local Speed = Base + Bonus
	
	max = max or 5
	min = min or 0
	
	if Speed <= max and Speed >= min then
		return true
	end
	
	return false
end;
Kitty.ComboManager.playerBowSpeedHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "BowSpeed1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "BowSpeed2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "BowSpeed3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerBowSpeedDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerBowSpeedDescription1"),
		Kitty.T("message", "playerBowSpeedDescription2"),
		Kitty.T("message", "playerBowSpeedDescription3"),
	};
end;
Kitty.ComboManager.playerBowSpeedType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.playerBowSpeedMinMax = function( self )
	return 0.5, 4
end

--------------------------------------------------------------------------------
-- 2020 Schrödinger -- New Utilities

Kitty.ComboManager.playerSelfEffect = function(self, condition)
	local result = true;
	for index, value in ipairs(condition) do
		if(value.effectType == "name") then
			-- Name
			local MainResult, _, isSelf = self.playerBuffManager:hasEffectByName(value.name, value.threshold, true );
			
			result = result and isSelf
		elseif(value.effectType == "id") then
			-- ID
			local MainResult, _, isSelf = self.playerBuffManager:hasEffectById(value.name, value.threshold, true );
			
			result = result and isSelf
		elseif(value.effectType == "original") then
			-- Original
			local MainResult, _, isSelf = self.playerBuffManager:hasEffect(value.name, value.threshold, true );
			
			result = result and isSelf
		else
			error("Invalid EffectType. EffectType:[" .. tostring(value.effectType) .. "]");
		end
	end
	return result;
end;
Kitty.ComboManager.playerSelfEffectHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		elseif value.threshold == nil or value.threshold == 0 then
			str = str .. Kitty.colorCyan(value.name);
		elseif value.threshold and value.threshold < 0.0 then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration1", math.abs(value.threshold)));
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "playerSelfEffect1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "playerSelfEffect2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.playerSelfEffectDescribe = function(self, condition)
	return {
		Kitty.T("message", "playerSelfEffectDescription1"),
		Kitty.T("message", "playerSelfEffectDescription2"),
		Kitty.T("message", "playerSelfEffectDescription3"),
	};
end;
Kitty.ComboManager.playerSelfEffectType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;

Kitty.ComboManager.playerNonSelfEffect = function(self, condition)
	return not Kitty.ComboManager.playerSelfEffect( self, condition )
end;

Kitty.ComboManager.playerNonSelfEffectHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		elseif value.threshold == nil or value.threshold == 0 then
			str = str .. Kitty.colorCyan(value.name);
		elseif value.threshold and value.threshold < 0.0 then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration1", math.abs(value.threshold)));
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "playerNonSelfEffect1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "playerNonSelfEffect2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.playerNonSelfEffectDescribe = function(self, condition)
	return {
		Kitty.T("message", "playerNonSelfEffectDescription1"),
		Kitty.T("message", "playerNonSelfEffectDescription2"),
		Kitty.T("message", "playerNonSelfEffectDescription3"),
	};
end;
Kitty.ComboManager.playerNonSelfEffectType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;

-------------------------------------------------------------------------------

Kitty.ComboManager.targetSelfEffect = function(self, condition)
	local result = true;
	for index, value in ipairs(condition) do
		if(value.effectType == "name") then
			-- Name
			local MainResult, _, isSelf = self.targetBuffManager:hasEffectByName(value.name, value.threshold, true );
			
			result = result and isSelf
		elseif(value.effectType == "id") then
			-- ID
			local MainResult, _, isSelf = self.targetBuffManager:hasEffectById(value.name, value.threshold, true );
			
			result = result and isSelf
		elseif(value.effectType == "original") then
			-- Original
			local MainResult, _, isSelf = self.targetBuffManager:hasEffect(value.name, value.threshold, true );
			
			result = result and isSelf
		else
			error("Invalid EffectType. EffectType:[" .. tostring(value.effectType) .. "]");
		end
	end
	return result;
end;
Kitty.ComboManager.targetSelfEffectHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		elseif value.threshold == nil or value.threshold == 0 then
			str = str .. Kitty.colorCyan(value.name);
		elseif value.threshold and value.threshold < 0.0 then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration1", math.abs(value.threshold)));
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "targetSelfEffect1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "targetSelfEffect2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.targetSelfEffectDescribe = function(self, condition)
	return {
		Kitty.T("message", "targetSelfEffectDescription1"),
		Kitty.T("message", "targetSelfEffectDescription2"),
		Kitty.T("message", "targetSelfEffectDescription3"),
	};
end;
Kitty.ComboManager.targetSelfEffectType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;

------------------------------------------------------------------------------------
Kitty.ComboManager.targetNonSelfEffect = function(self, condition)
	return not Kitty.ComboManager.targetSelfEffect( self, condition )
end;

Kitty.ComboManager.targetNonSelfEffectHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		elseif value.threshold == nil or value.threshold == 0 then
			str = str .. Kitty.colorCyan(value.name);
		elseif value.threshold and value.threshold < 0.0 then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration1", math.abs(value.threshold)));
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "targetNonSelfEffect1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "targetNonSelfEffect2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.targetNonSelfEffectDescribe = function(self, condition)
	return {
		Kitty.T("message", "targetNonSelfEffectDescription1"),
		Kitty.T("message", "targetNonSelfEffectDescription2"),
		Kitty.T("message", "targetNonSelfEffectDescription3"),
	};
end;
Kitty.ComboManager.targetNonSelfEffectType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;

Kitty.ComboManager.afterPlayerBuffEnded = function(self, condition)
	local result = false;
	for index, value in ipairs(condition) do
		if tonumber( value.name, 10 ) then
			-- ID
			local Data = Kitty.Buffs["player"] and Kitty.Buffs["player"][toName( value.name )]
			result = not Data or Data[2] == "ended" and GetTime() - Data[1] > value.threshold
		else
			-- Name
			local Data = Kitty.Buffs["player"] and Kitty.Buffs["player"][value.name]
			result = not Data or Data[2] == "ended" and GetTime() - Data[1] > value.threshold
		end
	end
	return result;
end;
Kitty.ComboManager.afterPlayerBuffEndedHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "BuffEndDuration", value.threshold));
		elseif value.threshold == nil or value.threshold <= 0 then
			str = str .. Kitty.colorCyan(value.name);
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "afterPlayerBuffEnded1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "afterPlayerBuffEnded2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.afterPlayerBuffEndedDescribe = function(self, condition)
	return {
		Kitty.T("message", "afterPlayerBuffEndedDescription1"),
		Kitty.T("message", "afterPlayerBuffEndedDescription2"),
		Kitty.T("message", "afterPlayerBuffEndedDescription3"),
	};
end;
Kitty.ComboManager.afterPlayerBuffEndedType = function(self, condition)
	return Kitty.ComboManager.TYPE_STRING_NUMBER_LIST;
end;
--------------------------------------------------------------------------------
Kitty.ComboManager.afterPlayerCastEnded = function(self, condition)
	local result = false;
	for index, value in ipairs(condition) do
		if tonumber( value.name, 10 ) then
			-- ID
			local Data = Kitty.LastCast and Kitty.LastCast[toName( value.name )]
			result = not Data or GetTime() - Data > value.threshold
		else
			-- Name
			local Data = Kitty.LastCast and Kitty.LastCast[value.name]
			result = not Data or GetTime() - Data > value.threshold
		end
	end
	return result;
end;
Kitty.ComboManager.afterPlayerCastEndedHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "BuffEndDuration", value.threshold));
		elseif value.threshold == nil or value.threshold <= 0 then
			str = str .. Kitty.colorCyan(value.name);
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "afterPlayerCastEnded1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "afterPlayerCastEnded2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.afterPlayerCastEndedDescribe = function(self, condition)
	return {
		Kitty.T("message", "afterPlayerCastEndedDescription1"),
		Kitty.T("message", "afterPlayerCastEndedDescription2"),
		Kitty.T("message", "afterPlayerCastEndedDescription3"),
	};
end;
Kitty.ComboManager.afterPlayerCastEndedType = function(self, condition)
	return Kitty.ComboManager.TYPE_STRING_NUMBER_LIST;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.afterTargetBuffEnded = function(self, condition)
	local result = false;
	for index, value in ipairs(condition) do
		if tonumber( value.name, 10 ) then
			-- ID
			local Data = Kitty.Buffs[UnitGUID( "target" )] and Kitty.Buffs[UnitGUID( "target" )][toName( value.name )]
			result = not Data or Data[2] == "ended" and GetTime() - Data[1] > value.threshold
		else
			-- Name
			local Data = Kitty.Buffs[UnitGUID( "target" )] and Kitty.Buffs[UnitGUID( "target" )][value.name]
			result = not Data or Data[2] == "ended" and GetTime() - Data[1] > value.threshold
		end
	end
	return result;
end;
Kitty.ComboManager.afterTargetBuffEndedHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "BuffEndDuration", value.threshold));
		elseif value.threshold == nil or value.threshold <= 0 then
			str = str .. Kitty.colorCyan(value.name);
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "afterTargetBuffEnded1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "afterTargetBuffEnded2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.afterTargetBuffEndedDescribe = function(self, condition)
	return {
		Kitty.T("message", "afterTargetBuffEndedDescription1"),
		Kitty.T("message", "afterTargetBuffEndedDescription2"),
		Kitty.T("message", "afterTargetBuffEndedDescription3"),
	};
end;
Kitty.ComboManager.afterTargetBuffEndedType = function(self, condition)
	return Kitty.ComboManager.TYPE_STRING_NUMBER_LIST;
end;


--------------------------------------------------------------------------------
-- PlayerのBuff/Debuff(どちらもあるなら)
Kitty.ComboManager.playerEffect = function(self, condition)
	local result = true;
	for index, value in ipairs(condition) do
		if(value.effectType == "name") then
			-- Name
			result = result and self.playerBuffManager:hasEffectByName(value.name, value.threshold);
		elseif(value.effectType == "id") then
			-- ID
			result = result and self.playerBuffManager:hasEffectById(value.name, value.threshold);
		elseif(value.effectType == "original") then
			-- Original
			result = result and self.playerBuffManager:hasEffect(value.name, value.threshold);
		else
			error("Invalid EffectType. EffectType:[" .. tostring(value.effectType) .. "]");
		end
	end
	return result;
end;
Kitty.ComboManager.playerEffectHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		elseif value.threshold == nil or value.threshold == 0 then
			str = str .. Kitty.colorCyan(value.name);
		elseif value.threshold and value.threshold < 0.0 then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration1", math.abs(value.threshold)));
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "PlayerEffect1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "PlayerEffect2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.playerEffectDescribe = function(self, condition)
	return {
		Kitty.T("message", "playerEffectDescription1"),
		Kitty.T("message", "playerEffectDescription2"),
		Kitty.T("message", "playerEffectDescription3"),
	};
end;
Kitty.ComboManager.playerEffectType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;
Kitty.ComboManager.targetOnMe = function(self, value)
	if(value == nil) then
		value = true;
	end
	local condition = UnitName("targettarget") == UnitName("player")
	if(value) then
		return condition
	else
		return not condition
	end
end;
Kitty.ComboManager.targetOnMeHelp = function(self, value)
	if(value) then
		return Kitty.T("message", "TargetOnMe1");
	else
		return Kitty.T("message", "TargetOnMe2");
	end
end;
Kitty.ComboManager.targetOnMeDescribe = function(self, value)
	return {
		Kitty.T("message", "targetOnMeDescription1"),
		Kitty.T("message", "targetOnMeDescription2"),
		Kitty.T("message", "targetOnMeDescription3"),
	};
end;
Kitty.ComboManager.targetOnMeType = function(self, value)
	return Kitty.ComboManager.TYPE_BOOLEAN;
end;
Kitty.ComboManager.isRequest = function(self, value)
	if(value == nil) then
		value = true;
	end
	if(value) then
		return IsShiftKeyDown()-- Kitty.isRequest;
	else
		return not IsShiftKeyDown() -- not Kitty.isRequest;
	end
end;
Kitty.ComboManager.isRequestHelp = function(self, value)
	if(value) then
		return Kitty.T("message", "IsRequestOn");
	else
		return Kitty.T("message", "IsRequestOff");
	end
end;
Kitty.ComboManager.isRequestDescribe = function(self, value)
	return {
		Kitty.T("message", "isRequestDescription1"),
		Kitty.T("message", "isRequestDescription2"),
		Kitty.T("message", "isRequestDescription3"),
	};
end;
Kitty.ComboManager.isRequestType = function(self, value)
	return Kitty.ComboManager.TYPE_BOOLEAN;
end;
Kitty.ComboManager.playerBuffStack = function(self, condition)
	local result = true;
	local count = 0;
	local loopEffectList = false
	for index, value in ipairs(condition) do
		if value.effectType == "original" then
			if type(Kitty.BuffManager.effectNameList[value.name].id)=="table" then
				loopEffectList = true
			end
		end
		for i = 1, MAX_BUFF_SIZE do
			local name, icon, buffcount, id = UnitBuff("player", i)
			
			if not name then break end
			
			if loopEffectList == false then
				if name == value.name or id == value.name then
					if buffcount == 0 then buffcount = 1 end
					count = count + buffcount
				end
			else
				for i,v in pairs(Kitty.BuffManager.effectNameList[value.name].id) do
					if id == v then
						if buffcount == 0 then buffcount = 1 end
						count = count + buffcount
					end
				end
			end
		end
		if value.threshold and tonumber(value.threshold) then
			result = result and count >= value.threshold
		else
			result = result and count > 0 
		end
	end
	return result;
end;
Kitty.ComboManager.playerBuffStackHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if value.threshold and tonumber(value.threshold) then
			if value.threshold < 0 then
				str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", 1));
			else
				str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", math.ceil(value.threshold)));
			end
		else
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", 1));
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "PlayerBuffStack1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "PlayerBuffStack2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.playerBuffStackDescribe = function(self, condition)
	return {
		Kitty.T("message", "playerBuffStackDescription1"),
		Kitty.T("message", "playerBuffStackDescription2"),
		Kitty.T("message", "playerBuffStackDescription3"),
	};
end;
Kitty.ComboManager.playerBuffStackType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;
Kitty.ComboManager.playerNonBuffStack = function(self, condition)
	local result = true;
	local count = 0;
	local loopEffectList = false
	for index, value in ipairs(condition) do
		if value.effectType == "original" then
			if type(Kitty.BuffManager.effectNameList[value.name].id)=="table" then
				loopEffectList = true
			end
		end
		for i = 1, MAX_BUFF_SIZE do
			local name, icon, buffcount, id = UnitBuff("player", i)
			
			if not name then break end
			
			if loopEffectList == false then
				if name == value.name or id == value.name then
					if buffcount == 0 then buffcount = 1 end
					count = count + buffcount
				end
			else
				for i,v in pairs(Kitty.BuffManager.effectNameList[value.name].id) do
					if id == v then
						if buffcount == 0 then buffcount = 1 end
						count = count + buffcount
					end
				end
			end
		end
		if value.threshold and tonumber(value.threshold) then
			result = result and count < value.threshold
		else
			result = result and count == 0 
		end
	end
	return result;
end;
Kitty.ComboManager.playerNonBuffStackHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if value.threshold and tonumber(value.threshold) then
			if value.threshold < 0 then
				str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", 1));
			else
				str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", math.ceil(value.threshold)));
			end
		else
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", 1));
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "PlayerBuffStack3"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "PlayerBuffStack4", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.playerNonBuffStackDescribe = function(self, condition)
	return {
		Kitty.T("message", "playerNonBuffStackDescription1"),
		Kitty.T("message", "playerNonBuffStackDescription2"),
		Kitty.T("message", "playerNonBuffStackDescription3"),
	};
end;
Kitty.ComboManager.playerNonBuffStackType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;
Kitty.ComboManager.targetDebuffStack = function(self, condition)
	local result = true;
	local count = 0;
	local playerCount = 0;
	local loopEffectList = false
	for index, value in ipairs(condition) do
		if value.effectType == "original" then
			if type(Kitty.BuffManager.effectNameList[value.name].id)=="table" then
				loopEffectList = true
			end
		end
		for i = 1, MAX_BUFF_SIZE do
			local name, icon, buffcount, id = UnitDebuff("target", i)
			
			if not name then break end
			
			if loopEffectList == false then
				if name == value.name or id == value.name then
					if buffcount == 0 then buffcount = 1 end
					count = count + buffcount
				end
			else
				for i,v in pairs(Kitty.BuffManager.effectNameList[value.name].id) do
					if id == v then
						if buffcount == 0 then buffcount = 1 end
						count = count + buffcount
					end
				end
			end
		end
		if value.threshold and tonumber(value.threshold) then
			result = result and count >= value.threshold
		elseif value.threshold then
			if string.lower(value.threshold) == "s" then
				for x = 1, 36 do
					if UnitHealth("raid"..x) > 0 then
						local m,s = UnitClassToken("raid"..x)
						if m == "RANGER" and s == "THIEF" then
							playerCount = playerCount + 1
						end
					end
				end
			elseif string.lower(value.threshold) == "w" then
				for x = 1, 36 do
					if UnitHealth("raid"..x) > 0 then
						local m,s = UnitClassToken("raid"..x)
						if m == "WARRIOR" and s ~= "MAGE" then
							local mainHandLink = GetInventoryItemLink("target",15)
							local _type,_data,_name = ParseHyperlink(mainHandLink)
							local id = tonumber(_data:match("(.-) .+") or _data)
							if id then
								local weapontype = GetObjectInfo(id,"weapontype")
								local possibleWeapons = {1,4,6,8}
								for _,v in pairs(possibleWeapons) do
									if v == weapontype then
										playerCount = playerCount + 1
									end
								end
							end
						end
					end
				end
			end
			result = result and count >= playerCount
		end
	end
	return result;
end;
Kitty.ComboManager.targetDebuffStackHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if value.threshold and tonumber(value.threshold) then
			if value.threshold < 0 then
				str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", 1));
			else
				str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", math.ceil(value.threshold)));
			end
		elseif value.threshold and string.lower(value.threshold) == "s" then
			str = str .. Kitty.colorCyan(value.name .. " x S/R in group");
		elseif value.threshold and string.lower(value.threshold) == "w" then
			str = str .. Kitty.colorCyan(value.name .. " x Warrior with Axe/Sword in group");
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "TargetDebuffStack1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "TargetDebuffStack2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.targetDebuffStackDescribe = function(self, condition)
	return {
		Kitty.T("message", "targetDebuffStackDescription1"),
		Kitty.T("message", "targetDebuffStackDescription2"),
		Kitty.T("message", "targetDebuffStackDescription3"),
	};
end;
Kitty.ComboManager.targetDebuffStackType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;
Kitty.ComboManager.targetNonDebuffStack = function(self, condition)
	local result = true;
	local count = 0;
	local loopEffectList = false
	for index, value in ipairs(condition) do
		if value.effectType == "original" then
			if type(Kitty.BuffManager.effectNameList[value.name].id)=="table" then
				loopEffectList = true
			end
		end
		for i = 1, MAX_BUFF_SIZE do
			local name, icon, buffcount, id = UnitDebuff("target", i)
			
			if not name then break end
			
			if loopEffectList == false then
				if name == value.name or id == value.name then
					if buffcount == 0 then buffcount = 1 end
					count = count + buffcount
				end
			else

				for i,v in pairs(Kitty.BuffManager.effectNameList[value.name].id) do
					if id == v then
						if buffcount == 0 then buffcount = 1 end
						count = count + buffcount
					end
				end
			end
		end
		if value.threshold and tonumber(value.threshold) then
			result = result and count < value.threshold
		else
			result = result and count == 0
		end
	end
	return result;
end;
Kitty.ComboManager.targetNonDebuffStackHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and" .. " ";
		end

		if value.threshold and tonumber(value.threshold) then
			if value.threshold < 0 then
				str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", 1));
			else
				str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", math.ceil(value.threshold)));
			end
		else
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "StackDuration", 1));
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "TargetDebuffStack3"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "TargetDebuffStack4", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.targetNonDebuffStackDescribe = function(self, condition)
	return {
		Kitty.T("message", "targetNonDebuffStackDescription1"),
		Kitty.T("message", "targetNonDebuffStackDescription2"),
		Kitty.T("message", "targetNonDebuffStackDescription3"),
	};
end;
Kitty.ComboManager.targetNonDebuffStackType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;
--------------------------------------------------------------------------------
-- PlayerのBuff/Debuff(どれもなければ)
Kitty.ComboManager.playerNonEffect = function(self, condition)
	local result = true;
	for index, value in ipairs(condition) do
		if(value.effectType == "name") then
			-- Name
			result = result and (not self.playerBuffManager:hasEffectByName(value.name, value.threshold));
		elseif(value.effectType == "id") then
			-- ID
			result = result and (not self.playerBuffManager:hasEffectById(value.name, value.threshold));
		elseif(value.effectType == "original") then
			-- Original
			result = result and (not self.playerBuffManager:hasEffect(value.name, value.threshold));
		else
			error("Invalid EffectType. EffectType:[" .. tostring(value.effectType) .. "]");
		end
	end
	return result;
end;
Kitty.ComboManager.playerNonEffectHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		else
			str = str .. Kitty.colorCyan(value.name);
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "PlayerEffect3"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "PlayerEffect4", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.playerNonEffectDescribe = function(self, condition)
	return {
		Kitty.T("message", "playerNonEffectDescription1"),
		Kitty.T("message", "playerNonEffectDescription2"),
		Kitty.T("message", "playerNonEffectDescription3"),
	};
end;
Kitty.ComboManager.playerNonEffectType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;

--------------------------------------------------------------------------------
-- TargetのBuff/Debuff(どちらもあるなら)
Kitty.ComboManager.targetEffect = function(self, condition)
	local result = true;
	for index, value in ipairs(condition) do
		if(value.effectType == "name") then
			-- Name
			result = result and self.targetBuffManager:hasEffectByName(value.name, value.threshold);
		elseif(value.effectType == "id") then
			-- ID
			result = result and self.targetBuffManager:hasEffectById(value.name, value.threshold);
		elseif(value.effectType == "original") then
			-- Original
			result = result and self.targetBuffManager:hasEffect(value.name, value.threshold);
		else
			error("Invalid EffectType. EffectType:[" .. tostring(value.effectType) .. "]");
		end
	end
	return result;
end;
Kitty.ComboManager.targetEffectHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		elseif value.threshold == nil or value.threshold == 0 then
			str = str .. Kitty.colorCyan(value.name);
		elseif value.threshold and value.threshold < 0.0 then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration1", math.abs(value.threshold)));
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "TargetEffect1"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "TargetEffect2", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.targetEffectDescribe = function(self, condition)
	return {
		Kitty.T("message", "targetEffectDescription1"),
		Kitty.T("message", "targetEffectDescription2"),
		Kitty.T("message", "targetEffectDescription3"),
	};
end;
Kitty.ComboManager.targetEffectType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;

--------------------------------------------------------------------------------
-- TargetのBuff/Debuff(どれもなければ)
Kitty.ComboManager.targetNonEffect = function(self, condition)
	local result = true;
	for index, value in ipairs(condition) do
		if(value.effectType == "name") then
			-- Name
			result = result and (not self.targetBuffManager:hasEffectByName(value.name, value.threshold));
		elseif(value.effectType == "id") then
			-- ID
			result = result and (not self.targetBuffManager:hasEffectById(value.name, value.threshold));
		elseif(value.effectType == "original") then
			-- Original
			result = result and (not self.targetBuffManager:hasEffect(value.name, value.threshold));
		else
			error("Invalid EffectType. EffectType:[" .. tostring(value.effectType) .. "]");
		end
	end
	return result;
end;
Kitty.ComboManager.targetNonEffectHelp = function(self, condition)
	local resultList = {};
	for index, value in ipairs(condition) do
		local str = "";
		if(index ~= 1) then
			str = str .. "and ";
		end

		if(value.threshold and value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		else
			str = str .. Kitty.colorCyan(value.name);
		end
		table.insert(resultList, str);
	end

	if(#resultList > 1) then
		table.insert(resultList, 1, Kitty.T("message", "TargetEffect3"));
	elseif(#resultList == 1) then
		resultList[1] = Kitty.T("message", "TargetEffect4", resultList[1]);
	end

	return resultList;
end;
Kitty.ComboManager.targetNonEffectDescribe = function(self, condition)
	return {
		Kitty.T("message", "targetNonEffectDescription1"),
		Kitty.T("message", "targetNonEffectDescription2"),
		Kitty.T("message", "targetNonEffectDescription3"),
	};
end;
Kitty.ComboManager.targetNonEffectType = function(self, condition)
	return Kitty.ComboManager.TYPE_EFFECT;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.playerHealth = function(self, min, max)
	return Kitty.ClassManager.hasHealthByRate("player", min, max);
end;
Kitty.ComboManager.playerHealthHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "HP1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "HP2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "HP3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerHealthDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerHealthDescription1"),
		Kitty.T("message", "playerHealthDescription2"),
		Kitty.T("message", "playerHealthDescription3"),
	};
end;
Kitty.ComboManager.playerHealthType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.playerHealthMinMax = function( self )
	return 0, 100
end
Kitty.ComboManager.targetHealth = function(self, min, max)
	return Kitty.ClassManager.hasHealthByRate("target", min, max);
end;
Kitty.ComboManager.targetHealthHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "TargetHP1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "TargetHP2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "TargetHP3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.targetHealthDescribe = function(self, min, max)
	return {
		Kitty.T("message", "targetHealthDescription1"),
		Kitty.T("message", "targetHealthDescription2"),
		Kitty.T("message", "targetHealthDescription3"),
	};
end;
Kitty.ComboManager.targetHealthType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.targetHealthMinMax = function( self )
	return 0, 100
end

--------------------------------------------------------------------------------
Kitty.ComboManager.playerMana = function(self, min, max)
	return Kitty.ClassManager.hasManaByRate("player", min, max);
end;
Kitty.ComboManager.playerManaHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "MP1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "MP2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "MP3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerManaDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerManaDescription1"),
		Kitty.T("message", "playerManaDescription2"),
		Kitty.T("message", "playerManaDescription3"),
	};
end;
Kitty.ComboManager.playerManaType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.playerManaMinMax = function( self )
	return 0, 100
end

--------------------------------------------------------------------------------
Kitty.ComboManager.playerTension = function(self, min, max)
	return Kitty.ClassManager.hasTension("player", min, max);
end;
Kitty.ComboManager.playerTensionHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "Tension1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "Tension2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "Tension3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerTensionDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerTensionDescription1"),
		Kitty.T("message", "playerTensionDescription2"),
		Kitty.T("message", "playerTensionDescription3"),
	};
end;
Kitty.ComboManager.playerTensionType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.playerTensionMinMax = function( self )
	return 0, 100
end

--------------------------------------------------------------------------------
Kitty.ComboManager.playerFocus = function(self, min, max)
	return Kitty.ClassManager.hasFocus("player", min, max);
end;
Kitty.ComboManager.playerFocusHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "Focus1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "Focus2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "Focus3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerFocusDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerFocusDescription1"),
		Kitty.T("message", "playerFocusDescription2"),
		Kitty.T("message", "playerFocusDescription3"),
	};
end;
Kitty.ComboManager.playerFocusType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.playerFocusMinMax = function( self )
	return 0, 200
end

--------------------------------------------------------------------------------
Kitty.ComboManager.playerEnergy = function(self, min, max)
	return Kitty.ClassManager.hasEnergy("player", min, max);
end;
Kitty.ComboManager.playerEnergyHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "Energy1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "Energy2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "Energy3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerEnergyDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerEnergyDescription1"),
		Kitty.T("message", "playerEnergyDescription2"),
		Kitty.T("message", "playerEnergyDescription3"),
	};
end;
Kitty.ComboManager.playerEnergyType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.playerEnergyMinMax = function( self )
	return 0, 100
end

--------------------------------------------------------------------------------
Kitty.ComboManager.playerSoulPoint = function(self, min, max)
	if(min == nil) then
		min = 0;
	end
	if(max == nil) then
		max = 6;
	end

	local point, _ = Kitty.ClassManager.getSoulPoint();
	if(min <= point and point <= max) then
		return true, point;
	else
		return false, point;
	end
end;
Kitty.ComboManager.playerSoulPointHelp = function(self, min, max)
	if(min == nil) then
		return Kitty.T("message", "SoulPoint1", Kitty.colorCyan(max));
	end
	if(max == nil) then
		return Kitty.T("message", "SoulPoint2", Kitty.colorCyan(min));
	end
	return Kitty.T("message", "SoulPoint3", Kitty.colorCyan(min), Kitty.colorCyan(max));
end;
Kitty.ComboManager.playerSoulPointDescribe = function(self, min, max)
	return {
		Kitty.T("message", "playerSoulPointDescription1"),
		Kitty.T("message", "playerSoulPointDescription2"),
		Kitty.T("message", "playerSoulPointDescription3"),
	};
end;
Kitty.ComboManager.playerSoulPointType = function(self, min, max)
	return Kitty.ComboManager.TYPE_NUMBER;
end;
Kitty.ComboManager.playerSoulPointMinMax = function( self )
	return 0, 6
end

--------------------------------------------------------------------------------
Kitty.ComboManager.playerName = function(self, value)
	local playerName = UnitName("player");
	if(playerName == nil) then
		return false;
	end

	local outData = Kitty.BuffManager.format(value, true);
	
	for name, bool in pairs(outData) do
		if string.sub(name, 1, 1) == "!" or string.sub(name, 1, 1) == "~" then
			if(playerName == string.sub(name, 2, string.len(name))) then
				return false;
			else
				return true;
			end
		else
			if(playerName == name) then
				return true;
			end
		end
	end
	return false;
end;
Kitty.ComboManager.playerNameHelp = function(self, value)
	-- 引数の型を統一
	local outData = Kitty.BuffManager.format(value, true);

	local str = "";
	for name, bool in pairs(outData) do
		if string.sub(name, 1, 1) == "!" or string.sub(name, 1, 1) == "~" then
			name = string.gsub(name, "!", "")
			name = string.gsub(name, "~", "")
			name = Kitty.colorCyan(name)
			return Kitty.T("message", "PlayerName1", name);
		else
			name = Kitty.colorCyan(name)
			return Kitty.T("message", "PlayerName1", name);
		end
	end
end;
Kitty.ComboManager.playerNameDescribe = function(self, value)
	return {
		Kitty.T("message", "playerNameDescription1"),
		Kitty.T("message", "playerNameDescription2"),
		Kitty.T("message", "playerNameDescription3"),
	};
end;
Kitty.ComboManager.playerNameType = function(self, value)
	return Kitty.ComboManager.TYPE_STRING;
end;
--------------------------------------------------------------------------------
Kitty.ComboManager.script = function(self, value)
	local outData = Kitty.BuffManager.format(value, true);
	for Script, _ in pairs(outData) do
		local fct,err = loadstring( ( Script:find("return") and "" or "return ") .. Script)
		if err then print(err) return false end
		return fct()
	end
	return false;
end
Kitty.ComboManager.scriptHelp = function(self, value)
	local outData = Kitty.BuffManager.format(value, true);

	for Script, _ in pairs(outData) do
		Script = Kitty.colorCyan(Script:sub(1,10) .. (Script:len() > 10 and " ..." or ""))
		return Kitty.T("message", "script", Script);
	end
end;
Kitty.ComboManager.scriptDescribe = function(self, value)
	return {
		Kitty.T("message", "scriptDescription1"),
		Kitty.T("message", "scriptDescription2"),
		Kitty.T("message", "scriptDescription3"),
	};
end;
Kitty.ComboManager.scriptType = function(self, value)
	return Kitty.ComboManager.TYPE_HIGH_STRING;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.timer = function(self, condition)
	Kitty.timers = Kitty.timers or {}
	for index, value in ipairs(condition) do
		if value and value.name and value.threshold then
			if UnitGUID("target") == nil then return false end
			Kitty.timers[value.name] = Kitty.timers[value.name] or {}
			Kitty.timers[value.name][UnitGUID("target")] = Kitty.timers[value.name][UnitGUID("target")] or false
			if Kitty.timers[value.name][UnitGUID("target")] == false then
				if GetTime() >= Kitty_GCD then
					Kitty.timers[value.name][UnitGUID("target")] = true
					local guid = UnitGUID("target")
					TimerQueue["KittyTimer_" .. value.name .. tostring( guid )] = { GetTime() + value.threshold, function() Kitty.timers[value.name][guid] = false end }
				end
				return true	
			else
				return false
			end
		end
	end
end
Kitty.ComboManager.timerHelp = function(self, condition)
	local str = "";
	local lefttime = "";
	for index, value in ipairs(condition) do
		if(str ~= "") then
			str = str .. ", ";
		end
		str = str .. Kitty.colorCyan(value.name);
		if(value.threshold > 0.0) then
			lefttime = Kitty.colorCyan(Kitty.T("message", "OverDuration", value.threshold))
		else
			str = str .. Kitty.colorCyan(value.name);
		end
	end
	return Kitty.T("message", "timer", str, lefttime);
end;
Kitty.ComboManager.timerDescribe = function(self, condition)
	return {
		Kitty.T("message", "timerDescription1"),
		Kitty.T("message", "timerDescription2"),
		Kitty.T("message", "timerDescription3"),
	};
end;
Kitty.ComboManager.timerType = function(self, condition)
	return Kitty.ComboManager.TYPE_STRING_NUMBER_LIST;
end;
--------------------------------------------------------------------------------
Kitty.ComboManager.targetName = function(self, value)
	local targetName = UnitName("target");
	if(targetName == nil) then
		return false;
	end
	-- 引数の型を統一
	local outData = Kitty.BuffManager.format(value, true);
	
	for name, bool in pairs(outData) do
		if string.sub(name, 1, 1) == "!" or string.sub(name, 1, 1) == "~" then
			if(targetName == string.sub(name, 2, string.len(name))) then
				return false;
			else
				return true;
			end
		else
			if(targetName == name) then
				return true;
			end
		end
	end
	return false;
end;
Kitty.ComboManager.targetNameHelp = function(self, value)
	-- 引数の型を統一
	local outData = Kitty.BuffManager.format(value, true);

	for name, bool in pairs(outData) do
		if string.sub(name, 1, 1) == "!" or string.sub(name, 1, 1) == "~" then
			name = string.gsub(name, "!", "")
			name = string.gsub(name, "~", "")
			name = Kitty.colorCyan(name)
			return Kitty.T("message", "TargetName1", name);
		else
			name = Kitty.colorCyan(name)
			return Kitty.T("message", "TargetName2", name);
		end
	end
end;
Kitty.ComboManager.targetNameDescribe = function(self, value)
	return {
		Kitty.T("message", "targetNameDescription1"),
		Kitty.T("message", "targetNameDescription2"),
		Kitty.T("message", "targetNameDescription3"),
	};
end;
Kitty.ComboManager.targetNameType = function(self, value)
	return Kitty.ComboManager.TYPE_STRING;
end;
--------------------------------------------------------------------------------
Kitty.ComboManager.playerClass = function(self, value)
	if(value == nil) then
		return false;
	end

	-- 引数の型を統一
	local outData = Kitty.BuffManager.format(value, true);

	local isExist = false;
	local orResult = false;
	local andResult = true;
	for combineClass, isTarget in pairs(outData) do
		if(isTarget) then
			-- どれか
			orResult = orResult or Kitty.BuildManager.matchWithTarget("player", combineClass);
			isExist = true;
		else
			-- どれも
			andResult = andResult and (not Kitty.BuildManager.matchWithTarget("player", combineClass));
		end
	end

	return ((orResult or (not isExist)) and andResult);
end;
Kitty.ComboManager.playerClassHelp = function(self, value)
	-- 引数の型を統一
	local outData = Kitty.BuffManager.format(value, true);

	local strTrue = "";
	local strFalse = "";
	for combineClass, isTarget in pairs(outData) do
		if(isTarget) then
			if(strTrue ~= "") then
				strTrue = strTrue .. ", ";
			end
			strTrue = strTrue .. Kitty.colorCyan(combineClass);
		else
			if(strFalse ~= "") then
				strFalse = strFalse .. ", ";
			end
			strFalse = strFalse .. Kitty.colorCyan(combineClass);
		end
	end

	-- メッセージ編集
	if(strTrue ~= "") then
		strTrue = Kitty.T("message", "PlayerState1", strTrue);
	end
	if(strFalse ~= "") then
		strFalse = Kitty.T("message", "PlayerState2", strFalse);
	end
	-- メッセージ複合
	if(strTrue ~= "" and strFalse ~= "") then
		return strTrue .. " " .. strFalse;
	else
		return strTrue .. strFalse;
	end
end;
Kitty.ComboManager.playerClassDescribe = function(self, value)
	return {
		Kitty.T("message", "playerClassDescription1"),
		Kitty.T("message", "playerClassDescription2"),
		Kitty.T("message", "playerClassDescription3"),
	};
end;
Kitty.ComboManager.playerClassType = function(self, value)
	return Kitty.ComboManager.TYPE_BUILD;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.targetClass = function(self, value)
	if(value == nil) then
		return false;
	end
	if(not Kitty.ClassManager.isPC("target")) then
		return false;
	end

	-- 引数の型を統一
	local outData = Kitty.BuffManager.format(value, true);

	local isExist = false;
	local orResult = false;
	local andResult = true;
	for combineClass, isTarget in pairs(outData) do
		if(isTarget) then
			-- どれか
			orResult = orResult or Kitty.BuildManager.matchWithTarget("target", combineClass);
			isExist = true;
		else
			-- どれも
			andResult = andResult and (not Kitty.BuildManager.matchWithTarget("target", combineClass));
		end
	end

	return ((orResult or (not isExist)) and andResult);
end;
Kitty.ComboManager.targetClassHelp = function(self, value)
	-- 引数の型を統一
	local outData = Kitty.BuffManager.format(value, true);

	local strTrue = "";
	local strFalse = "";
	for combineClass, isTarget in pairs(outData) do
		if(isTarget) then
			if(strTrue ~= "") then
				strTrue = strTrue .. ", ";
			end
			strTrue = strTrue .. Kitty.colorCyan(combineClass);
		else
			if(strFalse ~= "") then
				strFalse = strFalse .. ", ";
			end
			strFalse = strFalse .. Kitty.colorCyan(combineClass);
		end
	end

	-- メッセージ編集
	if(strTrue ~= "") then
		strTrue = Kitty.T("message", "TargetState1", strTrue);
	end
	if(strFalse ~= "") then
		strFalse = Kitty.T("message", "TargetState2", strFalse);
	end
	-- メッセージ複合
	if(strTrue ~= "" and strFalse ~= "") then
		return strTrue .. " " .. strFalse;
	else
		return strTrue .. strFalse;
	end
end;
Kitty.ComboManager.targetClassDescribe = function(self, value)
	return {
		Kitty.T("message", "targetClassDescription1"),
		Kitty.T("message", "targetClassDescription2"),
		Kitty.T("message", "targetClassDescription3"),
	};
end;
Kitty.ComboManager.targetClassType = function(self, value)
	return Kitty.ComboManager.TYPE_BUILD;
end;
--------------------------------------------------------------------------------
Kitty.ComboManager.targetIsDead = function(self, value)
	if(value== nil) then
		value = true;
	end
	if(value) then
		return UnitHealth("target") == 0
	else
		return UnitHealth("target") ~= 0
	end
end;
Kitty.ComboManager.targetIsDeadHelp = function(self, value)
	if(value) then
		return Kitty.T("message", "IsDead1");
	else
		return Kitty.T("message", "IsDead2");
	end
end;
Kitty.ComboManager.targetIsDeadDescribe = function(self, value)
	return {
		Kitty.T("message", "targetIsDeadDescription1"),
		Kitty.T("message", "targetIsDeadDescription2"),
		Kitty.T("message", "targetIsDeadDescription3"),
	};
end;
Kitty.ComboManager.targetIsDeadType = function(self, value)
	return Kitty.ComboManager.TYPE_BOOLEAN;
end;
--------------------------------------------------------------------------------
Kitty.ComboManager.targetIsPlayer = function(self, value)
	if(value== nil) then
		value = true;
	end
	if(value) then
		return Kitty.ClassManager.isPC("target");
	else
		return (not Kitty.ClassManager.isPC("target"));
	end
end;
Kitty.ComboManager.targetIsPlayerHelp = function(self, value)
	if(value) then
		return Kitty.T("message", "TargetState1", Kitty.colorCyan("PC"));
	else
		return Kitty.T("message", "TargetState2", Kitty.colorCyan("PC"));
	end
end;
Kitty.ComboManager.targetIsPlayerDescribe = function(self, value)
	return {
		Kitty.T("message", "targetIsPlayerDescription1"),
		Kitty.T("message", "targetIsPlayerDescription2"),
		Kitty.T("message", "targetIsPlayerDescription3"),
	};
end;
Kitty.ComboManager.targetIsPlayerType = function(self, value)
	return Kitty.ComboManager.TYPE_BOOLEAN;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.targetIsCasting = function(self, condition)
	local result = true
	for index, value in ipairs(condition) do
		result = result and  Kitty.ClassManager.isCasting("target", value.name, value.threshold);
	end
	return result
end;
Kitty.ComboManager.targetIsCastingHelp = function(self, condition)
	local str = "";
	for index, value in ipairs(condition) do
		if(str ~= "") then
			str = str .. ", ";
		end
		if value.threshold > 80 then value.threshold = 80 end
		if value.name == "" then
			if value.threshold > 0 then
				local msg = "something. "..Kitty.T("message", "CastingProgress", value.threshold)
				msg = Kitty.colorCyan(msg)
				return Kitty.T("message", "IsCasting", msg)
			else
				return Kitty.T("message", "IsCastingNameless")
			end
		end
		if(value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "CastingProgress", value.threshold));
		else
			str = str .. Kitty.colorCyan(value.name);
		end
	end
	return Kitty.T("message", "IsCasting", str);
end;
Kitty.ComboManager.targetIsCastingDescribe = function(self, condition)
	return {
		Kitty.T("message", "targetIsCastingDescription1"),
		Kitty.T("message", "targetIsCastingDescription2"),
		Kitty.T("message", "targetIsCastingDescription3"),
	};
end;
Kitty.ComboManager.targetIsCastingType = function(self, condition)
	return Kitty.ComboManager.TYPE_STRING_NUMBER_LIST;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.targetIsBoss = function(self, value)
	if(value== nil) then
		value = true;
	end

	if(UnitSex("target") >= 3) then
		return value;
	else
		return (not value);
	end
end;
Kitty.ComboManager.targetIsBossHelp = function(self, value)
	if(value) then
		return Kitty.T("message", "TargetState1", Kitty.colorCyan(Kitty.T("message", "KingBoss")));
	else
		return Kitty.T("message", "TargetState2", Kitty.colorCyan(Kitty.T("message", "KingBoss")));
	end
end;
Kitty.ComboManager.targetIsBossDescribe = function(self, value)
	return {
		Kitty.T("message", "targetIsBossDescription1"),
		Kitty.T("message", "targetIsBossDescription2"),
		Kitty.T("message", "targetIsBossDescription3"),
	};
end;
Kitty.ComboManager.targetIsBossType = function(self, value)
	return Kitty.ComboManager.TYPE_BOOLEAN;
end;
--------------------------------------------------------------------------------
Kitty.ComboManager.isCombat = function(self, value)
	if(value == nil) then
		value = true;
	end
	if(value) then
		return GetPlayerCombatState();
	else
		return (not GetPlayerCombatState());
	end
end;
Kitty.ComboManager.isCombatHelp = function(self, value)
	if(value) then
		return Kitty.T("message", "OnCombat");
	else
		return Kitty.T("message", "OffCombat");
	end
end;
Kitty.ComboManager.isCombatDescribe = function(self, value)
	return {
		Kitty.T("message", "isCombatDescription1"),
		Kitty.T("message", "isCombatDescription2"),
		Kitty.T("message", "isCombatDescription3"),
	};
end;
Kitty.ComboManager.isCombatType = function(self, value)
	return Kitty.ComboManager.TYPE_BOOLEAN;
end;

--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
Kitty.ComboManager.isTargeted = function(self, value)
	if(value== nil) then
		value = true;
	end
	if(value) then
		return UnitIsUnit("player", "targettarget");
	else
		return (not UnitIsUnit("player", "targettarget"));
	end
end;
Kitty.ComboManager.isTargetedHelp = function(self, value)
	if(value) then
		return Kitty.T("message", "Targeted");
	else
		return Kitty.T("message", "Untargeted");
	end
end;
Kitty.ComboManager.isTargetedDescribe = function(self, value)
	return {
		Kitty.T("message", "isTargetedDescription1"),
		Kitty.T("message", "isTargetedDescription2"),
		Kitty.T("message", "isTargetedDescription3"),
	};
end;
Kitty.ComboManager.isTargetedType = function(self, value)
	return Kitty.ComboManager.TYPE_BOOLEAN;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.canCast = function(self, condition)
	local result = true;
	for index, value in ipairs(condition) do
		result = result and self.skillManager:canCast(value.name);
	end
	return result;
end;
Kitty.ComboManager.canCastHelp = function(self, condition)
	local str = "";
	for index, value in ipairs(condition) do
		if(str ~= "") then
			str = str .. ", ";
		end

		if(value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		else
			str = str .. Kitty.colorCyan(value.name);
		end
	end
	return Kitty.T("message", "CanCast", str);
end;
Kitty.ComboManager.canCastDescribe = function(self, condition)
	return {
		Kitty.T("message", "canCastDescription1"),
		Kitty.T("message", "canCastDescription2"),
		Kitty.T("message", "canCastDescription3"),
	};
end;
Kitty.ComboManager.canCastType = function(self, condition)
	return Kitty.ComboManager.TYPE_STRING_NUMBER_LIST;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.canUse = function(self, condition)
	local result = true;
	for index, value in ipairs(condition) do
		result = result and self.slotManager:canUse(value.name);
	end
	return result;
end;
Kitty.ComboManager.canUseHelp = function(self, condition)
	local str = "";
	for index, value in ipairs(condition) do
		if(str ~= "") then
			str = str .. ", ";
		end

		if(value.threshold > 0.0) then
			str = str .. Kitty.colorCyan(value.name .. Kitty.T("message", "OverDuration", value.threshold));
		else
			str = str .. Kitty.colorCyan(value.name);
		end
	end
	return Kitty.T("message", "UsableMessage", str);
end;
Kitty.ComboManager.canUseDescribe = function(self, condition)
	return {
		Kitty.T("message", "canUseDescription1"),
		Kitty.T("message", "canUseDescription2"),
		Kitty.T("message", "canUseDescription3"),
	};
end;
Kitty.ComboManager.canUseType = function(self, condition)
	return Kitty.ComboManager.TYPE_STRING_NUMBER_LIST;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.isTwoHanded = function(self, value)
	if(value == nil) then
		value = true;
	end

	local isTwoHandedWeapon = nil
	if(Kitty.ClassManager.getWeaponType("player") == Kitty.ClassManager.TWO_HANDED) then
		isTwoHandedWeapon = true;
	else
		isTwoHandedWeapon = false;
	end

	if(value) then
		return isTwoHandedWeapon;
	else
		return not isTwoHandedWeapon;
	end
end;
Kitty.ComboManager.isTwoHandedHelp = function(self, value)
	if(value) then
		return Kitty.T("message", "TwoHanded");
	else
		return Kitty.T("message", "SingleHanded");
	end
end;
Kitty.ComboManager.isTwoHandedDescribe = function(self, value)
	return {
		Kitty.T("message", "isTwoHandedDescription1"),
		Kitty.T("message", "isTwoHandedDescription2"),
		Kitty.T("message", "isTwoHandedDescription3"),
	};
end;
Kitty.ComboManager.isTwoHandedType = function(self, value)
	return Kitty.ComboManager.TYPE_BOOLEAN;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.isShield = function(self, value)
	if(value == nil) then
		value = true;
	end

	local isShield = nil
	if(Kitty.ClassManager.getWeaponType("player") == Kitty.ClassManager.SHIELD) then
		isShield = true;
	else
		isShield = false;
	end

	if(value) then
		return isShield;
	else
		return not isShield;
	end
end;
Kitty.ComboManager.isShieldHelp = function(self, value)
	if(value) then
		return Kitty.T("message", "HasShield");
	else
		return Kitty.T("message", "HasNotShield");
	end
end;
Kitty.ComboManager.isShieldDescribe = function(self, value)
	return {
		Kitty.T("message", "isShieldDescription1"),
		Kitty.T("message", "isShieldDescription2"),
		Kitty.T("message", "isShieldDescription3"),
	};
end;
Kitty.ComboManager.isShieldType = function(self, value)
	return Kitty.ComboManager.TYPE_BOOLEAN;
end;

--------------------------------------------------------------------------------
Kitty.ComboManager.inRange = function(self, skill)
	local result = self.slotManager:inRange(skill);
	if(result ~= nil) then
		return self.slotManager:inRange(skill);
	else
		-- ショートカットなし
		SendWarningMsg(Kitty.format("Shortcut for inRange is not registered. SkillName:[<<1>>]", tostring(skill)));
		return false;
	end
end;
Kitty.ComboManager.inRangeHelp = function(self, skill)
	return Kitty.T("message", "InRange", Kitty.colorCyan(skill));
end;
Kitty.ComboManager.inRangeDescribe = function(self, skill)
	return {
		Kitty.T("message", "inRangeDescription1"),
		Kitty.T("message", "inRangeDescription2"),
		Kitty.T("message", "inRangeDescription3"),
	};
end;
Kitty.ComboManager.inRangeType = function(self, skill)
	return Kitty.ComboManager.TYPE_ACTION;
end;
--------------------------------------------------------------------------------
Kitty.ComboManager.check = function(self, targetList)
	for _, command in ipairs(targetList) do
		if(command.enable ~= false) then	-- nilは実行する
			local result = false;
			if(command.commandType == "skill") then
				result = self.skillManager:canCast(command.commandName);
			elseif(command.commandType == "suitskill") then
				result = self.skillManager:canCast(command.commandName);
			elseif(command.commandType == "equip") then -- 7.2
				local equipIndex = self.equipManager:cast(command.commandName, true);
				if equipIndex then
					local cd,remain = GetEquipItemCooldown(equipIndex);
					if not cd then result = false end
					if remain == 0 then result = true -- too lazy to add equipment manager
					else result = false end
				else
					result = false
				end
			elseif(command.commandType == "bag") then -- 7.3
				result = self.bagManager:canUse(command.commandName)
			elseif(command.commandType == "action") then
				result = self.slotManager:canUse(command.commandName);
			elseif(command.commandType == "extra") then
				local extraActionIndex = tonumber(command.commandName);
				if(extraActionIndex == nil) then
					local extraActionManager = Kitty.ExtraActionManager();
					result = extraActionManager:canUse(command.commandName);
				else
					result = Kitty.ExtraActionManager.canUseByIndex(extraActionIndex);
				end
			elseif(command.commandType == "macro") then
				result = self.macroManager:canExecute(command.commandName);
				if(result) then
					result = self.cooldownManager:canCast(command.commandName);
				end
			elseif(command.commandType == "emote") then
				local emotionManager = Kitty.EmotionManager();
				result = emotionManager:canEmote(command.commandName);
				if(result) then
					result = self.cooldownManager:canCast(command.commandName);
				end
			end

			if(result) then
				result = self:checkCondition(command);
			end

			if(result) then
				return command.commandType, command.commandName, nil;
			end
		end
	end

	return nil;
end;
-- コマンドの発動条件をチェック
Kitty.ComboManager.checkCondition = function(self, command)
	local result = true;

	-- 発動条件ごとにループ
	for _, condition in ipairs(command) do
		-- チェック関数実行
		local func = self[condition.conditionType];
		result = Kitty.pcall(func, self, Kitty.ComboManager.getArgument(condition));
		if condition.conditionType == "timer" then
		
		end

		if(result ~= true) then
			break;
		end
	end
	return result;
end;

Kitty.ComboManager.cast = function(self, commandType, command)
	if(commandType == "skill") or (commandType == "suitskill") then
		self.skillManager:cast(command);
	elseif(commandType == "action") then
		self.slotManager:use(command);
	elseif(commandType == "equip") then
		self.equipManager:cast(command);
	elseif(commandType == "bag") then
		self.bagManager:use(command)
	elseif(commandType == "extra") then
		local extraActionIndex = tonumber(command);
		if(extraActionIndex == nil) then
			local extraActionManager = Kitty.ExtraActionManager();
			extraActionManager:use(command);
		else
			Kitty.ExtraActionManager.useByIndex(extraActionIndex);
		end
	elseif(commandType == "macro") then
		local totalEstimatedPeriod = self.macroManager:execute(command);
		if(totalEstimatedPeriod == nil) then
			Kitty.sendMessage(Kitty.format("This macro cannot be executed. MacroName:[<<1>>]", tostring(command)), "DEFAULT", 1, 0, 0);
		else
			self.cooldownManager:onCast(command, totalEstimatedPeriod + 0.5);
		end
	elseif(commandType == "emote") then
		local emotionManager = Kitty.EmotionManager();
		emotionManager:doEmote(command);
		self.cooldownManager:onCast(command, 0.5);
	end
end;

-- コンストラクタ
Kitty.ComboManager.constructor = function(self, slotManager, cooldownManager, macroManager)
	-- データメンバ
	local obj = {};
	-- スロット管理クラス
	obj.slotManager = slotManager;
	-- クールダウン管理クラス
	obj.cooldownManager = cooldownManager;
	-- バフ情報管理クラス
	obj.targetBuffManager = Kitty.BuffManager();
	obj.targetBuffManager:update("target");
	obj.playerBuffManager = Kitty.BuffManager();
	obj.playerBuffManager:update("player");
	-- スキル管理クラス
	obj.skillManager = Kitty.SkillManager(cooldownManager);
	obj.equipManager = Kitty.EquipManager;
	obj.bagManager = Kitty.BagManager;
	obj.skillManager:update();
	-- マクロ管理クラス
	obj.macroManager = macroManager;

	return setmetatable(obj, {__index=Kitty.ComboManager});
end;
setmetatable(Kitty.ComboManager, {__call=Kitty.ComboManager.constructor});	-- コンストラクタを指定

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--[[
Kitty.ComboManager.commandList.[build].[Standard/Enhanced].vs[All/PC/PCCaster]

Kitty.ComboManager.commandList = {};
Kitty.ComboManager.commandList.WK = {};
Kitty.ComboManager.commandList.WK.vsAll = {};
Kitty.ComboManager.commandList.RS = {};
Kitty.ComboManager.commandList.RS.vsAll = {};
Kitty.ComboManager.commandList.RS.vsPC = {};
Kitty.ComboManager.commandList.RS.vsCaster = {
	{["skill"]="ウーンドアタック", ["playerBuff"]={"出血", ["流血"]=20.0}, ["playerEnergy"]={50, 100}},
};

skill				-- Skill名
playerEffect[]		-- PlayerのBuff/Debuff(どれかあるなら)
playerNonEffect[]	-- PlayerのBuff/Debuff(どれもなければ)
targetEffect[]		-- TargetのBuff/Debuff(どれかあるなら)
targetNonEffect[]	-- TargetのBuff/Debuff(どれもなければ)
playerHealth[]		-- PlayerのHP(単位は%)[min ～ max]
playerMana[]		-- Playerのマナ(単位は値)[min ～ max]
playerTension[]		-- Playerのテンション(単位は値)[min ～ max]
playerFocus[]		-- Playerのフォーカス(スカウトSP、単位は値)[min ～ max]
playerEnergy[]		-- Playerのエネルギー(ローグSP、単位は値)[min ～ max]
targetHealth[]
playerName[]
targetName[]
playerClass
targetClass
targetIsPlayer
targetIsCaster
targetIsBoss
isCombat
isTargeted
canCast
timer
isTwoHanded
isShield
inRange
func				-- 判定関数
note				-- "MPが50以上のときのみ"などのヘルプ
--]]
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
